/*
 * feedbackd auto-test
 *
 * Copyright (c) 2018 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "test.h"

static void test_main(int argc, char **argv)
{
	_I("Auto test all.");
	test_init((void *)NULL);
	test_exit((void *)NULL);
}

static void unit_test(int argc, char **argv)
{
	const struct test_ops *ops;

	ops = find_test("haptic");
	if (!ops) {
		_E("There is no test ops: haptic");
		return;
	}
	ops->unit(argc, argv);
}

void show_usage()
{
	printf("Usage: deviced-auto-test [UNIT-METHOD] [OPTS]\n\n");
	printf("Optional arguments\nIf you don't give any optional arguments, all supported modules will be tested.\n");
	printf("All module list is as below.\nAs per profile, supported modules are different.\n");
	printf("[UNIT-METHOD]		[OPTS]\n");
	printf("GetCount		0\n");
	printf("OpenDevice		0\n");
	printf("CloseDevice		0\n");
	printf("StopDevice		0\n");
	printf("VibrateMonotone		duration, level, priority\n");
	printf("VibratePattern		pattern string, level, priority\n");
	printf("GetState		0\n");
	printf("ShowHandleList		0\n");
	printf("IsSupported		pattern string\n");
}

int main(int argc, char **argv)
{
	if (argc == 2) {
		if (!strncmp(argv[1], "help", strlen("help") + 1)) {
			show_usage();
			return 0;
		}
	}

	if (argc >= 2)
		unit_test(argc, argv);
	else
		test_main(argc, argv);


	return 0;
}

